]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: ignore debugging messages
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115 unset NAME
116
117 add_gnupg_home () {
118     [ -e "${GNUPGHOME}/gpg.conf" ] && return
119     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120     at_exit_function _gnupg_exit
121     mkdir -p -m 0700 "$GNUPGHOME"
122     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123     test_debug "cat $GNUPGHOME/import.log"
124     if (gpg --quick-random --version >/dev/null 2>&1) ; then
125         echo quick-random >> "$GNUPGHOME"/gpg.conf
126     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
128     fi
129     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
130
131     # Change this if we ship a new test key
132     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
135 }
136
137 add_gpgsm_home () {
138     local fpr
139     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
140     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
141     at_exit_function _gnupg_exit
142     mkdir -p -m 0700 "$GNUPGHOME"
143     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
144         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
145         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
146               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
147     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
148     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
149     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
150     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
151     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
152     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
153               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
154     test_debug "cat $GNUPGHOME/import.log"
155 }
156
157 # Each test should start with something like this, after copyright notices:
158 #
159 # test_description='Description of this test...
160 # This test checks if command xyzzy does the right thing...
161 # '
162 # . ./test-lib.sh || exit 1
163
164 color=maybe
165
166 while test "$#" -ne 0
167 do
168         case "$1" in
169         -d|--debug)
170                 debug=t; shift ;;
171         -i|--immediate)
172                 immediate=t; shift ;;
173         -h|--help)
174                 help=t; shift ;;
175         -v|--verbose)
176                 verbose=t; shift ;;
177         -q|--quiet)
178                 quiet=t; shift ;;
179         --with-dashes)
180                 with_dashes=t; shift ;;
181         --no-color)
182                 color=; shift ;;
183         --no-python)
184                 # noop now...
185                 shift ;;
186         --valgrind)
187                 valgrind=t; verbose=t; shift ;;
188         --tee)
189                 shift ;; # was handled already
190         *)
191                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
192         esac
193 done
194
195 if test -n "$debug"; then
196     print_subtest () {
197         printf " %-4s" "[$((test_count - 1))]"
198     }
199 else
200     print_subtest () {
201         true
202     }
203 fi
204
205 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
206
207 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
208                 TERM=$ORIGINAL_TERM &&
209                 export TERM &&
210                 tput bold
211                 tput setaf
212                 tput sgr0
213         ) >/dev/null 2>&1
214 then
215         color=t
216 else
217         color=
218 fi
219
220 if test -n "$color"; then
221         say_color () {
222                 (
223                 TERM=$ORIGINAL_TERM
224                 export TERM
225                 case "$1" in
226                         error) tput bold; tput setaf 1;; # bold red
227                         skip)  tput bold; tput setaf 2;; # bold green
228                         pass)  tput setaf 2;;            # green
229                         info)  tput setaf 3;;            # brown
230                         *) test -n "$quiet" && return;;
231                 esac
232                 shift
233                 printf " "
234                 printf "$@"
235                 tput sgr0
236                 print_subtest
237                 )
238         }
239 else
240         say_color() {
241                 test -z "$1" && test -n "$quiet" && return
242                 shift
243                 printf " "
244                 printf "$@"
245                 print_subtest
246         }
247 fi
248
249 error () {
250         say_color error "error: $*\n"
251         GIT_EXIT_OK=t
252         exit 1
253 }
254
255 say () {
256         say_color info "$*"
257 }
258
259 test "${test_description}" != "" ||
260 error "Test script did not set test_description."
261
262 if test "$help" = "t"
263 then
264         echo "Tests ${test_description}"
265         exit 0
266 fi
267
268 test_description_printed=
269 print_test_description () {
270         test -z "$test_description_printed" || return 0
271         echo
272         echo $this_test: "Testing ${test_description}"
273         test_description_printed=1
274 }
275 if [ -z "$NOTMUCH_TEST_QUIET" ]
276 then
277         print_test_description
278 fi
279
280 test_failure=0
281 test_count=0
282 test_fixed=0
283 test_broken=0
284 test_success=0
285
286 declare -a _exit_functions=()
287
288 at_exit_function () {
289         _exit_functions=($1 ${_exit_functions[@]/$1})
290 }
291
292 rm_exit_function () {
293         _exit_functions=(${_exit_functions[@]/$1})
294 }
295
296 _exit_common () {
297         code=$?
298         trap - EXIT
299         set +ex
300         for _fn in ${_exit_functions[@]}; do $_fn; done
301         rm -rf "$TEST_TMPDIR"
302 }
303
304 trap_exit () {
305         _exit_common
306         if test -n "$GIT_EXIT_OK"
307         then
308                 exit $code
309         else
310                 exec >&6
311                 say_color error '%-6s' FATAL
312                 echo " $test_subtest_name"
313                 echo
314                 echo "Unexpected exit while executing $0. Exit code $code."
315                 exit 1
316         fi
317 }
318
319 trap_signal () {
320         _exit_common
321         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
322         exit $code
323 }
324
325 die () {
326         _exit_common
327         exec >&6
328         say_color error '%-6s' FATAL
329         echo " $*"
330         echo
331         echo "Unexpected exit while executing $0."
332         exit 1
333 }
334
335 GIT_EXIT_OK=
336 # Note: TEST_TMPDIR *NOT* exported!
337 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
338 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
339 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
340 trap 'trap_exit' EXIT
341 trap 'trap_signal' HUP INT TERM
342
343 # Add an existing, fixed corpus of email to the database.
344 #
345 # $1 is the corpus dir under corpora to add, using "default" if unset.
346 #
347 # The default corpus is based on about 50 messages from early in the
348 # history of the notmuch mailing list, which allows for reliably
349 # testing commands that need to operate on a not-totally-trivial
350 # number of messages.
351 add_email_corpus () {
352     local corpus
353     corpus=${1:-default}
354
355     rm -rf ${MAIL_DIR}
356     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
357     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
358 }
359
360 test_begin_subtest () {
361     if [ -n "$inside_subtest" ]; then
362         exec 1>&6 2>&7          # Restore stdout and stderr
363         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
364     fi
365     test_subtest_name="$1"
366     test_reset_state_
367     # Redirect test output to the previously prepared file descriptors
368     # 3 and 4 (see below)
369     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
370     exec >&3 2>&4
371     inside_subtest=t
372 }
373
374 # Pass test if two arguments match
375 #
376 # Note: Unlike all other test_expect_* functions, this function does
377 # not accept a test name. Instead, the caller should call
378 # test_begin_subtest before calling this function in order to set the
379 # name.
380 test_expect_equal () {
381         local output expected testname
382         exec 1>&6 2>&7          # Restore stdout and stderr
383         if [ -z "$inside_subtest" ]; then
384                 error "bug in the test script: test_expect_equal without test_begin_subtest"
385         fi
386         inside_subtest=
387         test "$#" = 2 ||
388         error "bug in the test script: not 2 parameters to test_expect_equal"
389
390         output="$1"
391         expected="$2"
392         if ! test_skip "$test_subtest_name"
393         then
394                 if [ "$output" = "$expected" ]; then
395                         test_ok_
396                 else
397                         testname=$this_test.$test_count
398                         echo "$expected" > $testname.expected
399                         echo "$output" > $testname.output
400                         test_failure_ "$(diff -u $testname.expected $testname.output)"
401                 fi
402     fi
403 }
404
405 # Like test_expect_equal, but takes two filenames.
406 test_expect_equal_file () {
407         local file1 file2 testname basename1 basename2
408         exec 1>&6 2>&7          # Restore stdout and stderr
409         if [ -z "$inside_subtest" ]; then
410                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
411         fi
412         inside_subtest=
413         test "$#" = 2 ||
414         error "bug in the test script: not 2 parameters to test_expect_equal_file"
415
416         file1="$1"
417         file2="$2"
418         if ! test_skip "$test_subtest_name"
419         then
420                 if diff -q "$file1" "$file2" >/dev/null ; then
421                         test_ok_
422                 else
423                         testname=$this_test.$test_count
424                         basename1=`basename "$file1"`
425                         basename2=`basename "$file2"`
426                         cp "$file1" "$testname.$basename1"
427                         cp "$file2" "$testname.$basename2"
428                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
429                 fi
430     fi
431 }
432
433 # Like test_expect_equal, but arguments are JSON expressions to be
434 # canonicalized before diff'ing.  If an argument cannot be parsed, it
435 # is used unchanged so that there's something to diff against.
436 test_expect_equal_json () {
437     local script output expected
438     # The test suite forces LC_ALL=C, but this causes Python 3 to
439     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
440     # override Python's stdio encoding defaults.
441     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
442     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
443         || echo "$1")
444     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
445         || echo "$2")
446     shift 2
447     test_expect_equal "$output" "$expected" "$@"
448 }
449
450 # Ensure that the argument is valid JSON data.
451 test_valid_json () {
452     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
453     test_expect_equal "$?" 0
454 }
455
456 # Sort the top-level list of JSON data from stdin.
457 test_sort_json () {
458     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
459         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
460 }
461
462 # test for json objects:
463 # read the source of test/json_check_nodes.py (or the output when
464 # invoking it without arguments) for an explanation of the syntax.
465 test_json_nodes () {
466         local output
467         exec 1>&6 2>&7          # Restore stdout and stderr
468         if [ -z "$inside_subtest" ]; then
469                 error "bug in the test script: test_json_eval without test_begin_subtest"
470         fi
471         inside_subtest=
472         test "$#" > 0 ||
473             error "bug in the test script: test_json_nodes needs at least 1 parameter"
474
475         if ! test_skip "$test_subtest_name"
476         then
477             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
478                 if [ "$?" = 0 ]
479                 then
480                         test_ok_
481                 else
482                         test_failure_ "$output"
483                 fi
484         fi
485 }
486
487 NOTMUCH_NEW () {
488     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
489 }
490
491 NOTMUCH_DUMP_TAGS () {
492     # this relies on the default format being batch-tag, otherwise some tests will break
493     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
494 }
495
496 notmuch_drop_mail_headers () {
497     $NOTMUCH_PYTHON -c '
498 import email, sys
499 msg = email.message_from_file(sys.stdin)
500 for hdr in sys.argv[1:]: del msg[hdr]
501 print(msg.as_string(False))
502 ' "$@"
503 }
504
505 notmuch_debug_sanitize () {
506     grep -v '^D.:'
507 }
508
509 notmuch_exception_sanitize () {
510     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
511 }
512
513 notmuch_search_sanitize () {
514     notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
515 }
516
517 notmuch_search_files_sanitize () {
518     notmuch_dir_sanitize
519 }
520
521 notmuch_dir_sanitize () {
522     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
523 }
524
525 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
526 notmuch_show_sanitize () {
527     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
528 }
529 notmuch_show_sanitize_all () {
530     notmuch_debug_sanitize | \
531     sed \
532         -e 's| filename:.*| filename:XXXXX|' \
533         -e 's| id:[^ ]* | id:XXXXX |' | \
534         notmuch_date_sanitize
535 }
536
537 notmuch_json_show_sanitize () {
538     sed \
539         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
540         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
541         -e 's|"filename": "signature.asc",||g' \
542         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
543         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
544         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
545 }
546
547 notmuch_emacs_error_sanitize () {
548     local command
549     command=$1
550     shift
551     for file in "$@"; do
552         echo "=== $file ==="
553         notmuch_debug_sanitize < "$file"
554     done | sed \
555         -e '/^$/d' \
556         -e '/^\[.*\]$/d' \
557         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
558 }
559
560 notmuch_date_sanitize () {
561     sed \
562         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
563 }
564
565 notmuch_uuid_sanitize () {
566     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
567 }
568
569 notmuch_built_with_sanitize () {
570     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
571 }
572
573 notmuch_config_sanitize () {
574     notmuch_dir_sanitize | notmuch_built_with_sanitize
575 }
576
577 notmuch_show_part () {
578     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
579 }
580
581 # End of notmuch helper functions
582
583 # Use test_set_prereq to tell that a particular prerequisite is available.
584 #
585 # The prerequisite can later be checked for by using test_have_prereq.
586 #
587 # The single parameter is the prerequisite tag (a simple word, in all
588 # capital letters by convention).
589
590 test_set_prereq () {
591         satisfied="$satisfied$1 "
592 }
593 satisfied=" "
594
595 test_have_prereq () {
596         case $satisfied in
597         *" $1 "*)
598                 : yes, have it ;;
599         *)
600                 ! : nope ;;
601         esac
602 }
603
604 declare -A test_missing_external_prereq_
605 declare -A test_subtest_missing_external_prereq_
606
607 # declare prerequisite for the given external binary
608 test_declare_external_prereq () {
609         local binary
610         binary="$1"
611         test "$#" = 2 && name=$2 || name="$binary(1)"
612
613         if ! hash $binary 2>/dev/null; then
614                 test_missing_external_prereq_["${binary}"]=t
615                 eval "
616 $binary () {
617         test_subtest_missing_external_prereq_[\"${name}\"]=t
618         false
619 }"
620         fi
621 }
622
623 # Explicitly require external prerequisite.  Useful when binary is
624 # called indirectly (e.g. from emacs).
625 # Returns success if dependency is available, failure otherwise.
626 test_require_external_prereq () {
627         local binary
628         binary="$1"
629         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
630                 # dependency is missing, call the replacement function to note it
631                 eval "$binary"
632         else
633                 true
634         fi
635 }
636
637 # You are not expected to call test_ok_ and test_failure_ directly, use
638 # the text_expect_* functions instead.
639
640 test_ok_ () {
641         if test "$test_subtest_known_broken_" = "t"; then
642                 test_known_broken_ok_
643                 return
644         fi
645         test_success=$(($test_success + 1))
646         if test -n "$NOTMUCH_TEST_QUIET"; then
647                 return 0
648         fi
649         say_color pass "%-6s" "PASS"
650         echo " $test_subtest_name"
651 }
652
653 test_failure_ () {
654         print_test_description
655         if test "$test_subtest_known_broken_" = "t"; then
656                 test_known_broken_failure_ "$@"
657                 return
658         fi
659         test_failure=$(($test_failure + 1))
660         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
661         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
662         return 1
663 }
664
665 test_failure_message_ () {
666         say_color error "%-6s" "$1"
667         echo " $2"
668         shift 2
669         if [ "$#" != "0" ]; then
670                 echo "$@" | sed -e 's/^/        /'
671         fi
672         if test "$verbose" != "t"; then cat test.output; fi
673 }
674
675 test_known_broken_ok_ () {
676         test_reset_state_
677         test_fixed=$(($test_fixed+1))
678         say_color pass "%-6s" "FIXED"
679         echo " $test_subtest_name"
680 }
681
682 test_known_broken_failure_ () {
683         test_reset_state_
684         test_broken=$(($test_broken+1))
685         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
686                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
687         else
688                 test_failure_message_ "BROKEN" "$test_subtest_name"
689         fi
690         return 1
691 }
692
693 test_debug () {
694         test "$debug" = "" || eval "$1"
695 }
696
697 test_run_ () {
698         test_cleanup=:
699         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
700         eval >&3 2>&4 "$1"
701         eval_ret=$?
702         eval >&3 2>&4 "$test_cleanup"
703         return 0
704 }
705
706 test_skip () {
707         test_count=$(($test_count+1))
708         to_skip=
709         for skp in $NOTMUCH_SKIP_TESTS
710         do
711                 case $this_test.$test_count in
712                 $skp)
713                         to_skip=t
714                         break
715                 esac
716                 case $this_test_bare.$test_count in
717                 $skp)
718                         to_skip=t
719                         break
720                 esac
721         done
722         case "$to_skip" in
723         t)
724                 test_report_skip_ "$@"
725                 ;;
726         *)
727                 test_check_missing_external_prereqs_ "$@"
728                 ;;
729         esac
730 }
731
732 test_check_missing_external_prereqs_ () {
733         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
734                 say_color skip >&1 "missing prerequisites: "
735                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
736                 test_report_skip_ "$@"
737         else
738                 false
739         fi
740 }
741
742 test_report_skip_ () {
743         test_reset_state_
744         say_color skip >&3 "skipping test:"
745         echo " $@" >&3
746         say_color skip "%-6s" "SKIP"
747         echo " $1"
748 }
749
750 test_subtest_known_broken () {
751         test_subtest_known_broken_=t
752 }
753
754 test_expect_success () {
755         exec 1>&6 2>&7          # Restore stdout and stderr
756         if [ -z "$inside_subtest" ]; then
757                 error "bug in the test script: test_expect_success without test_begin_subtest"
758         fi
759         inside_subtest=
760         test "$#" = 1 ||
761         error "bug in the test script: not 1 parameters to test_expect_success"
762
763         if ! test_skip "$test_subtest_name"
764         then
765                 test_run_ "$1"
766                 run_ret="$?"
767                 # test_run_ may update missing external prerequisites
768                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
769                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
770                 then
771                         test_ok_
772                 else
773                         test_failure_ "$1"
774                 fi
775         fi
776 }
777
778 test_expect_code () {
779         exec 1>&6 2>&7          # Restore stdout and stderr
780         if [ -z "$inside_subtest" ]; then
781                 error "bug in the test script: test_expect_code without test_begin_subtest"
782         fi
783         inside_subtest=
784         test "$#" = 2 ||
785         error "bug in the test script: not 2 parameters to test_expect_code"
786
787         if ! test_skip "$test_subtest_name"
788         then
789                 test_run_ "$2"
790                 run_ret="$?"
791                 # test_run_ may update missing external prerequisites,
792                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
793                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
794                 then
795                         test_ok_
796                 else
797                         test_failure_ "exit code $eval_ret, expected $1" "$2"
798                 fi
799         fi
800 }
801
802 # This is not among top-level (test_expect_success)
803 # but is a prefix that can be used in the test script, like:
804 #
805 #       test_expect_success 'complain and die' '
806 #           do something &&
807 #           do something else &&
808 #           test_must_fail git checkout ../outerspace
809 #       '
810 #
811 # Writing this as "! git checkout ../outerspace" is wrong, because
812 # the failure could be due to a segv.  We want a controlled failure.
813
814 test_must_fail () {
815         "$@"
816         test $? -gt 0 -a $? -le 129 -o $? -gt 192
817 }
818
819 # test_cmp is a helper function to compare actual and expected output.
820 # You can use it like:
821 #
822 #       test_expect_success 'foo works' '
823 #               echo expected >expected &&
824 #               foo >actual &&
825 #               test_cmp expected actual
826 #       '
827 #
828 # This could be written as either "cmp" or "diff -u", but:
829 # - cmp's output is not nearly as easy to read as diff -u
830 # - not all diff versions understand "-u"
831
832 test_cmp () {
833         $GIT_TEST_CMP "$@"
834 }
835
836 # This function can be used to schedule some commands to be run
837 # unconditionally at the end of the test to restore sanity:
838 #
839 #       test_expect_success 'test core.capslock' '
840 #               git config core.capslock true &&
841 #               test_when_finished "git config --unset core.capslock" &&
842 #               hello world
843 #       '
844 #
845 # That would be roughly equivalent to
846 #
847 #       test_expect_success 'test core.capslock' '
848 #               git config core.capslock true &&
849 #               hello world
850 #               git config --unset core.capslock
851 #       '
852 #
853 # except that the greeting and config --unset must both succeed for
854 # the test to pass.
855
856 test_when_finished () {
857         test_cleanup="{ $*
858                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
859 }
860
861 test_done () {
862         GIT_EXIT_OK=t
863         test_results_dir="$TEST_DIRECTORY/test-results"
864         mkdir -p "$test_results_dir"
865         test_results_path="$test_results_dir/$this_test"
866
867         echo "total $test_count" >> $test_results_path
868         echo "success $test_success" >> $test_results_path
869         echo "fixed $test_fixed" >> $test_results_path
870         echo "broken $test_broken" >> $test_results_path
871         echo "failed $test_failure" >> $test_results_path
872         echo "" >> $test_results_path
873
874         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
875
876         if [ "$test_failure" = "0" ]; then
877             if [ "$test_broken" = "0" ]; then
878                 rm -rf "$remove_tmp"
879             fi
880             exit 0
881         else
882             exit 1
883         fi
884 }
885
886 test_python () {
887     # Note: if there is need to print debug information from python program,
888     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
889     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
890         $NOTMUCH_PYTHON -B - > OUTPUT
891 }
892
893 test_C () {
894     local exec_file test_file
895     exec_file="test${test_count}"
896     test_file="${exec_file}.c"
897     cat > ${test_file}
898     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
899     echo "== stdout ==" > OUTPUT.stdout
900     echo "== stderr ==" > OUTPUT.stderr
901     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
902     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
903 }
904
905 make_shim () {
906     local base_name test_file shim_file
907     base_name="$1"
908     test_file="${base_name}.c"
909     shim_file="${base_name}.so"
910     cat > ${test_file}
911     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
912 }
913
914 notmuch_with_shim () {
915     local base_name shim_file
916     base_name="$1"
917     shift
918     shim_file="${base_name}.so"
919     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
920 }
921
922 # Creates a script that counts how much time it is executed and calls
923 # notmuch.  $notmuch_counter_command is set to the path to the
924 # generated script.  Use notmuch_counter_value() function to get the
925 # current counter value.
926 notmuch_counter_reset () {
927         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
928         if [ ! -x "$notmuch_counter_command" ]; then
929                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
930                 cat >"$notmuch_counter_command" <<EOF || return
931 #!/bin/sh
932
933 read count < "$notmuch_counter_state_path"
934 echo \$((count + 1)) > "$notmuch_counter_state_path"
935
936 exec notmuch "\$@"
937 EOF
938                 chmod +x "$notmuch_counter_command" || return
939         fi
940
941         echo 0 > "$notmuch_counter_state_path"
942 }
943
944 # Returns the current notmuch counter value.
945 notmuch_counter_value () {
946         if [ -r "$notmuch_counter_state_path" ]; then
947                 read count < "$notmuch_counter_state_path"
948         else
949                 count=0
950         fi
951         echo $count
952 }
953
954 test_reset_state_ () {
955         test -z "$test_init_done_" && test_init_
956
957         test_subtest_known_broken_=
958         test_subtest_missing_external_prereq_=()
959 }
960
961 # called once before the first subtest
962 test_init_ () {
963         test_init_done_=t
964
965         # skip all tests if there were external prerequisites missing during init
966         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
967 }
968
969
970 # Where to run the tests
971 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
972
973 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
974
975 # Use -P to resolve symlinks in our working directory so that the cwd
976 # in subprocesses like git equals our $PWD (for pathname comparisons).
977 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
978
979 if test "$verbose" = "t"
980 then
981         exec 4>&2 3>&1
982 else
983         exec 4>test.output 3>&4
984 fi
985
986 for skp in $NOTMUCH_SKIP_TESTS
987 do
988         to_skip=
989         for skp in $NOTMUCH_SKIP_TESTS
990         do
991                 case "$this_test" in
992                 $skp)
993                         to_skip=t
994                         break
995                 esac
996                 case "$this_test_bare" in
997                 $skp)
998                         to_skip=t
999                         break
1000                 esac
1001         done
1002         case "$to_skip" in
1003         t)
1004                 say_color skip >&3 "skipping test $this_test altogether"
1005                 say_color skip "skip all tests in $this_test"
1006                 test_done
1007         esac
1008 done
1009
1010 # Provide an implementation of the 'yes' utility
1011 yes () {
1012         if test $# = 0
1013         then
1014                 y=y
1015         else
1016                 y="$*"
1017         fi
1018
1019         while echo "$y"
1020         do
1021                 :
1022         done
1023 }
1024
1025 # Fix some commands on Windows
1026 case $(uname -s) in
1027 *MINGW*)
1028         # Windows has its own (incompatible) sort and find
1029         sort () {
1030                 /usr/bin/sort "$@"
1031         }
1032         find () {
1033                 /usr/bin/find "$@"
1034         }
1035         sum () {
1036                 md5sum "$@"
1037         }
1038         # git sees Windows-style pwd
1039         pwd () {
1040                 builtin pwd -W
1041         }
1042         # no POSIX permissions
1043         # backslashes in pathspec are converted to '/'
1044         # exec does not inherit the PID
1045         ;;
1046 *)
1047         test_set_prereq POSIXPERM
1048         test_set_prereq BSLASHPSPEC
1049         test_set_prereq EXECKEEPSPID
1050         ;;
1051 esac
1052
1053 test -z "$NO_PERL" && test_set_prereq PERL
1054 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1055
1056 # test whether the filesystem supports symbolic links
1057 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1058 rm -f y
1059
1060 # declare prerequisites for external binaries used in tests
1061 test_declare_external_prereq dtach
1062 test_declare_external_prereq emacs
1063 test_declare_external_prereq ${TEST_EMACSCLIENT}
1064 test_declare_external_prereq ${TEST_GDB}
1065 test_declare_external_prereq gpg
1066 test_declare_external_prereq openssl
1067 test_declare_external_prereq gpgsm
1068 test_declare_external_prereq ${NOTMUCH_PYTHON}
1069 test_declare_external_prereq xapian-metadata
1070 test_declare_external_prereq xapian-delve